/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 27.
   좮 .. - ॢ  ᪨ .
*/
/* See also pages 14ff in:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* CLIPDEMO:                                                 */
 /*  ࠡ ⬠ 祭              */
 /*  - ૥                                        */
 /* Demonstration of the Cohen & Sutherland line-clipping     */
 /* algorithm                                                 */

 #include "math.h"

 float xmin=1.0, xmax=7.0, ymin=2.0, ymax=6.0;

 main()
 { int i;
   float r, pi, alpha, phi0, phi, x0, y0, x1, y1, x2, y2;
   pi=4.0*atan(1.0); alpha=72.0*pi/180.0; phi0=0.0;
   x0=4.0; y0=4.0;
   initgr();                   /* 稢 ࠭  */
			       /* The window is now drawn: */
   move(xmin, ymin); draw(xmax, ymin); draw(xmax, ymax);
   draw(xmin, ymax); draw(xmin, ymin);
   /*  । ࠭  稢 20 ࠢ   */
   /* 業᪨ 㣮쭨:                      */
   /* As far as permitted by the boundaries of the window, */
   /* 20 concentric regular pentagons are drawn:           */
   for (r=0.5; r<10.5; r+=0.5)
   { x2=x0+r*cos(phi0); y2=y0+r*sin(phi0);
     for (i=1; i<=5; i++)
     { phi=phi0+i*alpha;
       x1=x2; y1=y2;
       x2=x0+r*cos(phi); y2=y0+r*sin(phi);
       clip(x1, y1, x2, y2);
     }
   }
   endgr();
 }

 int code(x, y) float x, y;
 { return (x<xmin)<<3 | (x>xmax)<<2 | (y<ymin)<<1 | (y>ymax);
 }

 clip(x1, y1, x2, y2) float x1, y1, x2, y2;
 { int c1=code(x1, y1), c2=code(x2, y2); float dx, dy;
   while (c1|c2)
   { if (c1&c2) return;
     dx=x2-x1; dy=y2-y1;
     if (c1)
     { if (x1<xmin) { y1 += dy*(xmin-x1)/dx; x1=xmin; } else
       if (x1>xmax) { y1 += dy*(xmax-x1)/dx; x1=xmax; } else
       if (y1<ymin) { x1 += dx*(ymin-y1)/dy; y1=ymin; } else
       if (y1>ymax) { x1 += dx*(ymax-y1)/dy; y1=ymax; }
       c1=code(x1, y1);
     } else
     { if (x2<xmin) { y2 += dy*(xmin-x2)/dx; x2=xmin; } else
       if (x2>xmax) { y2 += dy*(xmax-x2)/dx; x2=xmax; } else
       if (y2<ymin) { x2 += dx*(ymin-y2)/dy; y2=ymin; } else
       if (y2>ymax) { x2 += dx*(ymax-y2)/dy; y2=ymax; }
       c2=code(x2, y2);
     }
   }
   move(x1, y1); draw(x2, y2);
 }
