/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 98.
   좮 .. - ॢ  ᪨ .
*/
/* See also page 79 in:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* GPERS:               ணࠬ  ஥
			ᯥ⨢ ࠦ
			General program for PERSpective */

 #include "math.h"
 #include "stdio.h"

 float v11, v12, v13, v21, v22, v23, v32, v33, v43,
       screen_dist, c1=4.5, c2=3.5;

 main(argc, argv) int argc; char *argv[];
 { float rho, theta, phi, xO, yO, zO, x, y, z;
   int code;
   FILE *fp;
   if (argc != 2) { printf /* "No file name given" */
		  ("   䠩"); exit(1); }
   if (fp=fopen(argv[1],"r"), fp==NULL)
   { printf /* "File .... does not exist" */
	    ("   %s  ", argv[1]); exit(1);
   }
   fscanf(fp, "%f %f %f", &xO, &yO, &zO); skipf(fp);
   fscanf(fp, "%f %f %f %f", &rho, &theta, &phi, &screen_dist);
   coeff(rho, theta, phi);
   initgr();
   while (skipf(fp), fscanf(fp, "%f %f %f %d",
                                 &x, &y, &z, &code) > 0)
     if (code) dw(x-xO, y-yO, z-zO); else mv(x-xO, y-yO, z-zO);
   endgr();
 }

 skipf(fp) FILE *fp; { while (getc(fp) != '\n'); }

 coeff(rho, theta, phi) float rho, theta, phi;
 { float th, ph, costh, sinth, cosph, sinph, factor;
   factor=atan(1.0)/45.0;
		/* Angles in radians: */  /*   ࠤ */
   th=theta*factor; ph=phi*factor;
   costh=cos(th); sinth=sin(th);
   cosph=cos(ph); sinph=sin(ph);
		     /* Elements of matrix V, see Eq. (4-9): */
		     /*   V, . (4.9):       */
   v11=-sinth; v12=-cosph*costh; v13=-sinph*costh;
   v21=costh;  v22=-cosph*sinth; v23=-sinph*sinth;
               v32=sinph;        v33=-cosph;
                                 v43=rho;
 }

 mv(x, y, z) float x, y, z;
 { float X, Y;
   perspective(x, y, z, &X, &Y);
   move(X, Y);
 }

 dw(x, y, z) float x, y, z;
 { float X, Y;
   perspective(x, y, z, &X, &Y);
   draw(X, Y);
 }

 perspective(x, y, z, pX, pY) float x, y, z, *pX, *pY;
 { float xe, ye, ze;

	     /* Eye coordinates, computed as in Eq. (4-2): */
	     /*  न,  塞  (4.2): */
   xe = v11*x + v21*y;
   ye = v12*x + v22*y + v32*z;
   ze = v13*x + v23*y + v33*z + v43;

		      /* Screen coordinates, computed as   */
		      /* in Eqs. (4-12) and (4-13):        */
    /* ࠭ न, 塞  (4.12)  (4.13) */
   *pX = screen_dist*xe/ze + c1;
   *pY = screen_dist*ye/ze + c2;
 }
