/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 124.
   좮 .. - ॢ  ᪨ .
*/
/* See also page 101 in:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* HIDLIN:     ணࠬ  㤠   . */
 /*             ࠡ ⮩ ணࠬ  뢠   */
 /*            䠩 A.SCRATCH,  ।祭   - */
 /*             ணࠬ GENPLOT                         */

 /*            A simple program for hidden-line elimination.    */
 /*            The output of this program is the file A.SCRATCH,*/
 /*            which is to be read by GENPLOT.                  */

 #include "stdio.h"
 #include "math.h"

 #define NVERTEX 50
 #define NTRIANGLE 50

 unsigned int _STACK=15000;  /* Lattice C */
 int ntr=0;
 double v11, v12, v13, v21, v22, v23, v32, v33, v43,
   eps=1e-5, meps=-1e-5, oneminus=1-1.e-5, oneplus=1+1.e-5;

 FILE *fpout;

 struct { float X, Y; int code; } s;

 struct { double x, y, z; } VERTEX [NVERTEX];
 struct { int A, B, C; double a, b, c, h; }
                         TRIANGLE [NTRIANGLE];

 main(argc, argv) int argc; char *argv[];
 { int i, A, B, C, P, Q;
   double xO, yO, zO, rho, theta, phi, x, y, z,
      xA, yA, zA, xB, yB, zB, xC, yC, zC,
      a, b, c, h, r;

   FILE *fpin;
   int ch;

   if (argc!=2 || (fpin=fopen(argv[1], "r"))==NULL)
     errmess /* "Input file not correctly specified" */
	    ("室 䠩  ४⭮");

   fscanf(fpin, "%lf %lf %lf", &xO, &yO, &zO); skipf(fpin);
   fscanf(fpin, "%lf %lf %lf", &rho, &theta, &phi);
   coeff(rho, theta, phi);
   while (skipf(fpin), ch=getc(fpin), ch!='#' && ch!=EOF)
   { ungetc(ch, fpin);
     fscanf(fpin, "%d %lf %lf %lf", &i, &x, &y, &z);
     if (i<0 || i>=NVERTEX) errmess /* "illegal vertex number" */
				   ("ࠢ  設");
     viewing(x-xO, y-yO, z-zO,
        &VERTEX[i].x, &VERTEX[i].y, &VERTEX[i].z);
     if (VERTEX[i].z<=eps)
     { printf /* "Object point O and vertex ... lie on " */
	      ("窠 ꥪ O  設 %d  ", i);
       errmess /* "different sides of viewpoint E." */
	      ("ࠧ ஭  窨  E.");
     }
   }

   while (skipf(fpin), ch=getc(fpin), ch!='#' && ch!=EOF)
   { ungetc(ch, fpin);
     fscanf(fpin, "%d %d %d", &A, &B, &C);
     xA=VERTEX[A].x; yA=VERTEX[A].y; zA=VERTEX[A].z;
     xB=VERTEX[B].x; yB=VERTEX[B].y; zB=VERTEX[B].z;
     xC=VERTEX[C].x; yC=VERTEX[C].y; zC=VERTEX[C].z;
     a = yA * (zB-zC) - yB * (zA-zC) + yC * (zA-zB);
     b = -(xA * (zB-zC) - xB * (zA-zC) + xC * (zA-zB));
     c = xA * (yB-yC) - xB * (yA-yC) + xC * (yA-yB);
     h = xA * (yB*zC - yC*zB) -
         xB * (yA*zC - yC*zA) +
         xC * (yA*zB - yB*zA);
     if (h>0)
     { if (ntr == NTRIANGLE) errmess /* "Too many triangles" */
				("誮  㣮쭨");
       r = sqrt(a*a+b*b+c*c);
       a = a/r; b = b/r; c = c/r; h = h/r;
       TRIANGLE[ntr].A = A;
       TRIANGLE[ntr].B = B;
       TRIANGLE[ntr].C = C;
       TRIANGLE[ntr].a = a;
       TRIANGLE[ntr].b = b;
       TRIANGLE[ntr].c = c;
       TRIANGLE[ntr++].h = h;
     }
   /* If h=0, plane ABC passes through E and hides nothing.  */
   /* If h<0, triangle ABC is a backface.                    */
   /* In both cases ntr is not incremented and the triangle  */
   /* is not stored.                                         */
   /* ᫨ h=0,  ᪮ ABC 室  १   E   */
   /* 祣  뢠. ᫨ h<0,  㣮쭨  */
   /* .       ࠬ  ntr    砥 */
   /* 饭  㣮쭨  .              */
   }

   fpout=fopen("a.scratch", "wb");
		    /* required in Lattice C for binary mode */
		    /* ࠬ "b"  ୮ ०     */
   if (fpout==NULL)
		errmess /* "file a.scratch cannot be opened" */
			   (" a.scratch  ");

   while (skipf(fpin), fscanf(fpin, "%d %d", &P, &Q) >0)
     linesegment(VERTEX[P].x, VERTEX[P].y, VERTEX[P].z,
           VERTEX[Q].x, VERTEX[Q].y, VERTEX[Q].z, 0);
   fclose(fpout);
 }

 skipf(fpin) FILE *fpin;
 { int ch;
   while (ch=getc(fpin), ch != '\n' && ch != EOF);
 }

 errmess(str) char *str; { printf("%s\n", str); exit(1); }

 coeff(rho, theta, phi) double rho, theta, phi;
 { double th, ph, costh, sinth, cosph, sinph, factor;
   factor=atan(1.0)/45.0;
	       /* Angles in radians: */  /*   ࠤ */
   th=theta*factor; ph=phi*factor;
   costh=cos(th); sinth=sin(th);
   cosph=cos(ph); sinph=sin(ph);
		    /* Elements of matrix V, see Eq. (4-9): */
		    /*   V, . (4.9):       */
   v11=-sinth; v12=-cosph*costh; v13=-sinph*costh;
   v21=costh;  v22=-cosph*sinth; v23=-sinph*sinth;
               v32=sinph;        v33=-cosph;
                                 v43=rho;
 }

 viewing(x, y, z, pxe, pye, pze)
   double x, y, z, *pxe, *pye, *pze;
 {           /* Eye coordinates, computed as in Eq. (4-2): */
	     /*  न, 塞   (4.2): */
   *pxe = v11*x + v21*y;
   *pye = v12*x + v22*y + v32*z;
   *pze = v13*x + v23*y + v33*z + v43;
 }

 linesegment(xP, yP, zP, xQ, yQ, zQ, j0)
   double xP, yP, zP, xQ, yQ, zQ; int j0;
 { /* Line segment PQ is to be drawn, as far as it is   */
   /* not hidden by the triangles j0, j0+1, ..., ntr.   */
   /* १ אַ PQ   祭, ᪮ */
   /*   뢠 㣮쭨 j0,j0+1,..., ntr.*/
   int j=j0, worktodo=1, A, B, C, i, Pbeyond, Qbeyond,
       outside, Poutside, Qoutside, eA, eB, eC, sum;
   double a, b, c, h, hP, hQ, r1, r2, r3,
	  xA, yA, zA, xB, yB, zB, xC, yC, zC,
	  dA, dB, dC, MIN, MAX, lab, mu,
	  xmin, ymin, zmin, xmax, ymax, zmax,
	  C1, C2, C3, K1, K2, K3, denom1, denom2,
	  Cpos, Ppos, Qpos, aux, eps1;
   while (j<ntr)
   { a=TRIANGLE[j].a; b=TRIANGLE[j].b; c=TRIANGLE[j].c;
     h=TRIANGLE[j].h; eps1=eps+eps*h;

				    /* Test 1: */  /*  1 */
     hP=a*xP+b*yP+c*zP; hQ=a*xQ+b*yQ+c*zQ;
     if (hP<=h+eps1 && hQ<=h+eps1) {j++; continue;}
					/* PQ not behind ABC */
		     /* १ PQ   㣮쭨 ABC*/

				     /* Test 2: */ /*  2 */
     K1=yP*zQ-yQ*zP; K2=zP*xQ-zQ*xP; K3=xP*yQ-xQ*yP;
     A=TRIANGLE[j].A; B=TRIANGLE[j].B; C=TRIANGLE[j].C;
     xA=VERTEX[A].x; yA=VERTEX[A].y; zA=VERTEX[A].z;
     xB=VERTEX[B].x; yB=VERTEX[B].y; zB=VERTEX[B].z;
     xC=VERTEX[C].x; yC=VERTEX[C].y; zC=VERTEX[C].z;
     dA=K1*xA+K2*yA+K3*zA;
     dB=K1*xB+K2*yB+K3*zB;
     dC=K1*xC+K2*yC+K3*zC;
   /* If dA, dB, dC have the same sign, the vertices A, B, C */
   /* lie at the same side of plane EPQ.                     */
   /* ᫨  dA, dB, dC    ,    設 */
   /* A, B, C ᯮ    ஭   ᪮ EPQ */
     eA= dA>eps ? 1 : dA<meps ? -1 : 0;
     eB= dB>eps ? 1 : dB<meps ? -1 : 0;
     eC= dC>eps ? 1 : dC<meps ? -1 : 0;
     sum = eA+eB+eC;
     if (abs(sum)>=2) { j++; continue; }
    /* If this test succeeds, the (infinite) line PQ lies   */
    /* outside pyramid EABC (at most one common point).     */
    /* If the test fails, there is a point of intersection. */
    /* ᫨   襭 ᯥ譮,  (᪮筠)    */
    /* ﬠ  PQ   ࠬ EABC              */
    /* (   ࠩ    ).        */
    /* ᫨   믮,   窠 祭. */

				   /* Test 3: */  /*  3 */
     Poutside=Qoutside=0; MIN=1.; MAX=0.;
     for (i=0; i<3; i++)
     { C1=yA*zB-yB*zA; C2=zA*xB-zB*xA; C3=xA*yB-xB*yA;
		    /* C1 x + C2 y + C3 z = 0  is plane EAB */
		    /* ࠢ 뢠 ᪮ EAB    */
       Cpos=C1*xC+C2*yC+C3*zC;
       Ppos=C1*xP+C2*yP+C3*zP;
       Qpos=C1*xQ+C2*yQ+C3*zQ;
       denom1=Qpos-Ppos;
       if (Cpos>eps)
       { Pbeyond= Ppos<meps; Qbeyond= Qpos<meps;
         outside= Pbeyond && Qpos<=eps ||
                  Qbeyond && Ppos<=eps;
       } else if (Cpos<meps)
       { Pbeyond= Ppos>eps; Qbeyond= Qpos>eps;
         outside= Pbeyond && Qpos>=meps ||
                  Qbeyond && Ppos>=meps;
       } else outside=1;
       if (outside) break;
       lab= fabs(denom1)<=eps  ? 1.e7 : -Ppos/denom1;
	       /* lab indicates where PQ meets plane EAB      */
	       /* ࠬ lab 㪠뢠   祭 */
	       /* १ PQ  ᪮ EAB                 */
       Poutside |= Pbeyond;
       Qoutside |= Qbeyond;
       denom2=dB-dA;
       mu= fabs(denom2)<=eps ? 1.e7 : -dA/denom2;
		/* mu tells where AB meets plane EPQ          */
		/* ࠬ mu 㪠뢠   祭 */
		/* १ AB  ᪮ EPQ                */
       if (mu>=meps && mu<=oneplus &&
           lab>=meps && lab<=oneplus)
       { if (lab<MIN) MIN=lab;
         if (lab>MAX) MAX=lab;
       }
       aux=xA; xA=xB; xB=xC; xC=aux;
       aux=yA; yA=yB; yB=yC; yC=aux;
       aux=zA; zA=zB; zB=zC; zC=aux;
       aux=dA; dA=dB; dB=dC; dC=aux;
     }
     if (outside) {j++; continue;}

				    /* Test 4: */  /*  4 */
     if (!(Poutside || Qoutside))
     { worktodo=0; break;                    /* PQ invisible */
				     /* १ PQ  */
     }

				     /* Test 5: */ /*  5 */
     r1=xQ-xP; r2=yQ-yP; r3=zQ-zP;
     xmin=xP+MIN*r1; ymin=yP+MIN*r2; zmin=zP+MIN*r3;
     if (a*xmin+b*ymin+c*zmin<h-eps1) { j++; continue; }
     xmax=xP+MAX*r1; ymax=yP+MAX*r2; zmax=zP+MAX*r3;
     if (a*xmax+b*ymax+c*zmax<h-eps1) { j++; continue; }

     /* If this test succeeds, an intersection of PQ          */
     /* and the pyramid lies in front of plane ABC.           */
     /* ᫨   믮 ᯥ譮,  窠 祭 */
     /* १ PQ  ࠬ 室 । ᪮ ABC. */

				     /* Test 6: */  /*  6 */
     if (Poutside)
       linesegment(xP, yP, zP, xmin, ymin, zmin, j+1);
     if (Qoutside)
       linesegment(xQ, yQ, zQ, xmax, ymax, zmax, j+1);
     worktodo=0; break;
   }

   if (worktodo)
   { s.X=xP/zP; s.Y=yP/zP; s.code=0;
     fwrite(&s, sizeof s, 1, fpout);
     s.X=xQ/zQ; s.Y=yQ/zQ; s.code=1;
     fwrite(&s, sizeof s, 1, fpout);
   }
 }