/* ᠭ ணࠬ .   .ࠫ, "ਭ樯
   ணࠬ஢  設 䨪", ., 1991, . 146.
   좮 .. - ॢ  ᪨ .
*/
/* See also page 119 in:
   L. Ammeraal (1986). Programming Principles in Computer Graphics,
   Chichester: John Wiley & Sons.
*/

 /* HIDLINPX:						*/
 /*              ணࠬ 㤠     */
 /*              ᭮ ਡ୮-ᨬ ᥫ   */

 /*              A program for hidden-line elimination, */
 /*              using device-independent pixels        */

#include <stdio.h>
#include <math.h>
#include <ctype.h>

#define max2(x,y)    ((x)>(y)?(x):(y))
#define min2(x,y)    ((x)<(y)?(x):(y))

#define max3(x,y,z) ((x)>(y)?max2(x,z):max2(y,z))
#define min3(x,y,z) ((x)<(y)?min2(x,z):min2(y,z))
#define xwhole(x)   ((int)(((x)-Xmin)/deltaX))
#define ywhole(y)   ((int)(((y)-Ymin)/deltaY))
#define xreal(i)    (Xmin+((i))*deltaX)

#define M -1000000.0
#define nvertex 800   /* maximum number of vertices */
		      /* ᨬ쭮  ᫮ 設 */
#define ntriangle 600
 /* maximum number of (no backface) triangles to be stored */
 /* ᨬ쭮 ⢮ 㣮쭨,       */
 /*  ( )                            */
#define Nscreen 15
#define big 1.e30;
#define NPOLY 400
	/* maximum number of vertices of a  single polygon */
	/* ᨬ쭮 ⢮ 設    */
#define nntrset 200
	    /* maximum size of set of triangles associated */
	    /* with  a single  (long)  line  segment       */
	    /* ᨬ쭠 稭  㣮쭨, */
	    /* 樨㥬     ()  १ */

 int ntr=0, iaux, ipixmin, ipixmax, ipixleft, ipixright, ipix,
     jpix, jtop, jbot, j_old, l, jI, topcode[3], POLY[NPOLY],
     npoly,isize=sizeof(int), LOWER[Nscreen], UPPER[Nscreen],
     LOW[Nscreen], UP[Nscreen], trset[nntrset], ntrset;

 double v11, v12, v13, v21, v22, v23, v32, v33, v43, d, c1, c2,
   eps=1e-5, meps=-1e-5, oneminus=1-1.e-5, oneplus=1+1.e-5,
   Xrange, Yrange, Xvp_range, Yvp_range, Xmin, Xmax, Ymin,
   Ymax, deltaX, deltaY, denom, slope,
   Xleft[3], Xright[3], Yleft[3], Yright[3];

 char *malloc(), *realloc();

 struct { double x, y, z; int *connect; } VERTEX [nvertex],
   *pvertex;

 struct { int A, B, C; double a, b, c, h; }
                         TRIANGLE [ntriangle], *ptriangle;

 struct node { int jtr; struct node *next; } *pnode;

 struct { int tr_cov; double tr_dist; struct node *start; }
      SCREEN[Nscreen][Nscreen], *pointer;

   FILE *fpin;

 /*---------------------------------------------------------*/
 main(argc, argv) int argc; char *argv[];
 { int i, P, Q, ii, imin, vertexnr,
   *ptr, iconnect, i0, i1, i2, code, count,
   trnr, jtr;

   double xO, yO, zO, rho, theta, phi, x, y, z,
     X, Y, xe, ye, ze,
     diag, min_diag, Xvp_min, Xvp_max, Yvp_min, Yvp_max,
     fx, fy, Xcentre, Ycentre, Xvp_centre, Yvp_centre,
     xP, yP, zP, xQ, yQ, zQ, XP, YP, XQ, YQ,
     Xlft, Xrght, Ylft, Yrght;

   char ch;

   if (argc!=2 || (fpin=fopen(argv[1], "r"))==NULL)
   { printf /* "Input file not correctly specified" */
		("室 䠩 㪠 ४⭮\n"); exit(1);
   }

/* Initialize screen matrix *//* 樨஢ ࠭  */
   for (ipix=0; ipix<Nscreen; ipix++)
   for (jpix=0; jpix<Nscreen; jpix++)
   { pointer=&(SCREEN[ipix][jpix]);
     pointer->tr_cov=-1; pointer->tr_dist=big;
     pointer->start=NULL;
   }

   reflo(&xO); reflo(&yO); reflo(&zO);
   printf /* Give spherical coordinates rho, theta, phi  of  */
	  /* viewpoint E (phi = angle between z-axis and OE) */
	 (" ᪨ न rho, theta, phi ");
   printf(" 窨  E\n(phi = 㣮 ");
   printf("  z  ࠢ १ OE):\n");
   scanf("%lf %lf %lf", &rho, &theta, &phi);
   coeff(rho, theta, phi);
   init_viewport(&Xvp_min, &Xvp_max, &Yvp_min, &Yvp_max);

 /* Initialize vertex array *//* 樨஢ ᨢ 設 */
   for (i=0; i<nvertex; i++) VERTEX[i].connect=NULL;

 /* Read vertices    */  /* 뢠 न 設 */
   Xmin=Ymin=big; Xmax=Ymax=-big;
   while (skipbl(), ch=getc(fpin), ch!='F' && ch!='f')
   { ungetc(ch, fpin);
     reint(&i); reflo(&x); reflo(&y); reflo(&z);
     if (i<0 || i>=nvertex) errmes /* illegal vertex number */
	(" 設 ⥫   ᨬ쭮 (300)");
     viewing(x-xO, y-yO, z-zO, &xe, &ye, &ze);
     if (ze <= eps)
       errmes
/* "Object point O and a vertex on different sides of viewpoint E */
 ("窠 ꥪ O  設  ࠧ ஭  窨  E");
     X=xe/ze;  Y=ye/ze;
     if (X<Xmin) Xmin=X; if (X>Xmax) Xmax=X;
     if (Y<Ymin) Ymin=Y; if (Y>Ymax) Ymax=Y;
     VERTEX[i].x=xe; VERTEX[i].y=ye; VERTEX[i].z=ze;
     VERTEX[i].connect = ptr = (int*)malloc(isize);
     if (ptr==NULL) errmes /* "Memory allocation error 1" */
			  ("訡 1 । ");
     *ptr=0;
   }
			       /* Compute screen constants     */
			       /* ᫥ ࠭ ⠭ */
   Xrange=Xmax-Xmin; Yrange=Ymax-Ymin;
   Xvp_range=Xvp_max-Xvp_min; Yvp_range=Yvp_max-Yvp_min;
   fx=Xvp_range/Xrange; fy=Yvp_range/Yrange;
   d=(fx<fy ? fx : fy);
   Xcentre=0.5*(Xmin+Xmax); Ycentre=0.5*(Ymin+Ymax);
   Xvp_centre=0.5*(Xvp_min+Xvp_max);
   Yvp_centre=0.5*(Yvp_min+Yvp_max);
   c1=Xvp_centre-d*Xcentre; c2=Yvp_centre-d*Ycentre;
   deltaX=oneplus*Xrange/Nscreen;
   deltaY=oneplus*Yrange/Nscreen;
   /* Now we have:  Xrange/deltaX < Nscreen */
   /*  : Xrange/deltaX < Nscreen */

       /* Read object faces and store triangles */
       /* 뢠 ᠭ ࠭   㣮쭨 */
   while (! isspace(getc(fpin)));
	       /* The string "Faces: " has now been skipped */
	       /* ப  ᫮ "Faces:" 㤥 ய饭 */

   while (reint(&i)>0)
   { POLY[0]=i; npoly=1; skipbl();
     while (ch=getc(fpin), ch != '#')
     { ungetc(ch, fpin); reint(&POLY[npoly++]);
       if (npoly==NPOLY)
	 errmes /* "Too many vertices in one polygon" */
		("誮  設   ");
     }
     if (npoly==1) errmes /* "Only one vertex of polygon" */
			("  ⮫쪮  設");
     if (npoly==2)
     { add_linesegment(POLY[0], POLY[1]);
       continue;
     }

     if (!counter_clock(0, 1, 2, &diag, 0)) continue;
			/*  ࠭ */	/* backface */

     for (i=1; i<=npoly; i++)
     { ii=i%npoly; code=POLY[ii]; vertexnr=abs(code);
       if (VERTEX[vertexnr].connect==NULL)
	 errmes /* "Undefined vertex number used" */
	       ("ᯮ짮  । 設");
       if (code<0) POLY[ii]=vertexnr; else
         add_linesegment(POLY[i-1], vertexnr);
     }

     /* Division of a polygon into triangles (see Section 3-5): */
     /*      㣮쭨  (. ࠧ 3-5): */
     count=1;
     while (npoly>2)
     { min_diag=big;
       for (i1=0; i1<npoly; i1++)
       { i0= (i1==0 ? npoly-1 : i1-1);
         i2= (i1==npoly-1 ? 0 : i1+1);
         if (counter_clock(i0, i1, i2, &diag,0) &&
                                          diag<min_diag)
         { min_diag=diag; imin=i1;
         }
       }
       i1=imin;
       i0= (i1==0 ? npoly-1 : i1-1);
       i2= (i1==npoly-1 ? 0 : i1+1);
 /* store triangle in array TRIANGLE and in screen lists: */
 /*  㣮쭨  ᨢ TRIANGLE           */
 /*   ࠭ ᯨ᪠:                                 */
       counter_clock(i0, i1, i2, &diag, count++);
       npoly--;
       for (ii=i1; ii<=npoly; ii++) POLY[ii]=POLY[ii+1];
     }
   }
   fclose(fpin);

 /* Add nearest triangles to screen lists:  */
 /*  饣 㣮쭨  ࠭ ᯨ᪨ */
   for (ipix=0; ipix<Nscreen; ipix++)
   for (jpix=0; jpix<Nscreen; jpix++)
   { pointer=&(SCREEN[ipix][jpix]);
     if ((*pointer).tr_cov >= 0)
     { pnode=(struct node *)malloc(sizeof(struct node));
       if (pnode==NULL) errmes /* "Memory allocation error 2" */
			      ("訡 2 । ");
       pnode->jtr=pointer->tr_cov;
       pnode->next=pointer->start;
       pointer->start=pnode;
     }
   }

 /* Draw all line segments as far as they are visible */
 /* 稢 १      */
   for (P=0; P<nvertex; P++)
   { pvertex=VERTEX+P; /* = &VERTEX[P] */
     ptr = pvertex->connect;
     if (ptr == NULL) continue;
     xP = pvertex->x; yP = pvertex->y; zP = pvertex->z;
     XP= xP/zP; YP=yP/zP;
     for (iconnect=1; iconnect<=*ptr; iconnect++)
     { Q = *(ptr+iconnect);
       pvertex=VERTEX+Q; /* = &VERTEX[Q] */
       xQ = pvertex->x; yQ = pvertex->y; zQ = pvertex->z;
       XQ=xQ/zQ; YQ=yQ/zQ;

  /* Using the screen lists, we shall build the   */
  /* set of triangles that may hide points of PQ: */
  /*  ᭮ ࠭ ᯨ᪮ ।  㣮쭨, */
  /*   뢠  窨  १  אַ   PQ */

       if (XP<XQ || (XP==XQ && YP<YQ))
       {Xlft=XP; Ylft=YP; Xrght=XQ; Yrght=YQ; } else
       {Xlft=XQ; Ylft=YQ; Xrght=XP; Yrght=YP; }
       ipixleft=xwhole(Xlft); ipixright=xwhole(Xrght);
       denom=Xrght-Xlft; if (fabs(denom)<=eps) denom=eps;
       slope=(Yrght-Ylft)/denom; jbot=jtop=ywhole(Ylft);
       for (ipix=ipixleft; ipix<=ipixright; ipix++)
       { if (ipix==ipixright) jI=ywhole(Yrght); else
                 jI=ywhole(Ylft+(xreal(ipix+1)-Xlft)*slope);
	 LOWER[ipix]=min2(jbot,jI); jbot=jI;
	 UPPER[ipix]=max2(jtop,jI); jtop=jI;
       }
       ntrset=0;
       for (ipix=ipixleft; ipix<=ipixright; ipix++)
       for (jpix=LOWER[ipix]; jpix<=UPPER[ipix]; jpix++)
       { pointer=&(SCREEN[ipix][jpix]);
         pnode= pointer->start;
         while (pnode!=NULL)
         { trnr= pnode->jtr;
       /* trnr will be stored only if it is not yet */
       /* present in array trset (the triangle set) */
       /*  trnr 㤥  ⮫쪮  ⮬ 砥, ᫨ */
       /*      ᨢ  trset ( 㣮쭨) */
	   trset[ntrset]=trnr;     /* sentinel */  /* "cࠦ" */
           jtr=0;
           while (trset[jtr]!=trnr)jtr++;
           if (jtr==ntrset)
	   { ntrset++; /* this means that trnr is stored */
	     /*  砥,  trnr ᠭ  ᨢ */
             if (ntrset==nntrset)
		  errmes /* "Triangle set overflow" */
			 (" 㣮쭨 ९\n");
           }
           pnode=pnode->next;
         }
       }
       /* Now trset[0], ..., trset[ntrset-1] is the set of */
       /* triangles that may hide points of PQ.            */
       /*  ᯨ᮪ trset[0], ..., trset[ntrset-1] । */
       /*  㣮쭨,    뢠  窨 PQ */

       linesegment(xP, yP, zP, xQ, yQ, zQ, 0);
     }
   }
   endgr();
 }

 /*--------------------------------------------------------*/
 skipbl()
 { char ch;
   do ch=getc(fpin); while (isspace(ch)||comment(ch));
   ungetc(ch,fpin);
 }
 /*--------------------------------------------------------*/
 int comment(ch) char ch;
 { int k;
   if (ch=='(')
   { do k=getc(fpin); while (k != ')' && k != EOF);
     return k==')';
   } else return 0;
 }

 /*--------------------------------------------------------*/
 int reflo(px) double *px;
 { skipbl(); return fscanf(fpin, "%lf", px);
 }

 /*--------------------------------------------------------*/
 int reint(pi) int *pi;
 { skipbl(); return fscanf(fpin, "%d", pi);
 }

 /*--------------------------------------------------------*/
 add_linesegment(P, Q) int P, Q;
 { int iaux, *ptr, ii, n;
   if (P>Q) { iaux=P; P=Q; Q=iaux; }
   /* Now: P < Q */
   ptr=VERTEX[P].connect; n=*ptr;
   for (ii=1; ii<=n; ii++)
     if (*(ptr+ii)==Q) return; /* Q already in list */
			       /* Q  㦥    ᯨ᪥ */
   n++;
   VERTEX[P].connect=ptr=(int *)realloc(ptr, (n+1)*isize);
   if (ptr==NULL) errmes /* "Memory allocation error 3" */
			("訡 3 । ");
   *(ptr+n)=Q; *ptr=n;
 }


 /*--------------------------------------------------------*/
 int counter_clock(i0, i1, i2, pdist, code)
    int i0, i1, i2, code; double *pdist;

 /* code = 0: compute orientation; if counter-clockwise,   */
 /*           compute length of projected diagonal AC      */
 /* code = 1: compute a, b, c, h; store the first triangle */
 /* code > 1: check if next triangle is coplanar; store it */
 /*                                                        */
 /* code = 0: ਥ : ᫨ ⨢ ᮢ ५,  */
 /*           ᫥  ஥樨  AC       */
 /* code = 1: ᫥ a, b, c, h;  ࢮ   */
 /*           㣮쭨                                 */
 /* code > 1: ஢ઠ  ୮ ᫥饣 -   */
 /*           쭨;                    */

 { int A=abs(POLY[i0]), B=abs(POLY[i1]), C=abs(POLY[i2]);
   double xA, yA, zA, xB, yB, zB, xC, yC, zC, r,
         xdist, ydist, zdist,
         XA, YA, XB, YB, XC, YC, h0,
         DA, DB, DC, D, DAB, DAC, DBC, aux, dist,
         xR, yR;
   static double a, b, c, h;

   pvertex=VERTEX+A;
   xA = pvertex->x; yA = pvertex->y; zA = pvertex->z;

   pvertex=VERTEX+B;
   xB = pvertex->x; yB = pvertex->y; zB = pvertex->z;

   pvertex=VERTEX+C;
   xC = pvertex->x; yC = pvertex->y; zC = pvertex->z;
   h0 = xA * (yB*zC - yC*zB) -
        xB * (yA*zC - yC*zA) +
        xC * (yA*zB - yB*zA);

   if (code==0)
     if (h0>eps)
     { xdist=xC-xA; ydist=yC-yA; zdist=zC-zA;
       *pdist=xdist*xdist+ydist*ydist+zdist*zdist;
       return 1;
     } else return 0;
   /* If h0=0, plane ABC passes through E and hides nothing.  */
   /* If h0<0, triangle ABC is a backface.                    */
   /* In both cases ntr is not incremented and the triangles  */
   /* of the polygon are not stored.                          */
   /*                                                         */
   /* ᫨ h0=0,  ᪮ ABC 室 १  E     */
   /*            祣  뢠.                         */
   /* ᫨ h0<0,  㣮쭨 ABC - .                 */
   /*    ६ ntr  砥 饭   */
   /*  㣮쭨    .              */
   if (code==1)
   { a = yA * (zB-zC) - yB * (zA-zC) + yC * (zA-zB);
     b = -(xA * (zB-zC) - xB * (zA-zC) + xC * (zA-zB));
     c = xA * (yB-yC) - xB * (yA-yC) + xC * (yA-yB);
     r = sqrt(a*a+b*b+c*c); if (r==0.0) r=eps;
     a = a/r; b = b/r; c = c/r; h = h0/r;
   } else if (fabs(a*xC+b*yC+c*zC-h)>0.001*fabs(h))
       errmes /* Incorrectly specified polygon */
		("  ४⭮");
   if (ntr == ntriangle) errmes /* "Too many triangles" */
				("誮  㣮쭨");
   ptriangle=TRIANGLE+ntr; /* = &TRIANGLE[ntr] */
   ptriangle->A = A; ptriangle->B = B ; ptriangle->C = C;
   ptriangle->a = a; ptriangle->b = b ; ptriangle->c = c;
   ptriangle->h = h;

   /* The triangle will now be stored in the screen lists  */
   /* of the associated pixels; first the arrays LOWER,    */
   /* UPPER, LOW, UP are defined:                          */
   /*  㣮쭨 㦭    ࠭ ᯨ᪨ */
   /* 樨஢  ᥫ,    ᭠砫   室 */
   /* । ᨢ LOWER, UPPER, LOW, UP.            */
   XA=xA/zA; YA=yA/zA;
   XB=xB/zB; YB=yB/zB;
   XC=xC/zC; YC=yC/zC;
   DA=XB*YC-XC*YB; DB=XC*YA-XA*YC; DC=XA*YB-XB*YA; D=DA+DB+DC;
   DAB=DC-M*(XA-XB); DAC=DB-M*(XC-XA); DBC=DA-M*(XB-XC);
   topcode[0]=(D*DAB>0); topcode[1]=(D*DAC>0);
   topcode[2]=(D*DBC>0);
   Xleft[0]=XA; Yleft[0]=YA; Xright[0]=XB; Yright[0]=YB;
   Xleft[1]=XA; Yleft[1]=YA; Xright[1]=XC; Yright[1]=YC;
   Xleft[2]=XB; Yleft[2]=YB; Xright[2]=XC; Yright[2]=YC;
   for (l=0; l<3; l++)            /* l = triangle-side number */
	  /* ६ l 砥  ஭ 㣮쭨 */
   if (Xleft[l]>Xright[l] ||
      (Xleft[l]==Xright[l] && Yleft[l]>Yright[l]))
   { aux=Xleft[l]; Xleft[l]=Xright[l]; Xright[l]=aux;
     aux=Yleft[l]; Yleft[l]=Yright[l]; Yright[l]=aux;
   }
   ipixmin=xwhole(min3(XA,XB,XC));
   ipixmax=xwhole(max3(XA,XB,XC));
   for (ipix=ipixmin; ipix<=ipixmax; ipix++)
   { LOWER[ipix]=UP[ipix]=10000;
     UPPER[ipix]=LOW[ipix]=-10000;
   }

   for (l=0; l<3; l++)
   { ipixleft=xwhole(Xleft[l]); ipixright=xwhole(Xright[l]);
     denom=Xright[l]-Xleft[l];
     if (ipixleft != ipixright) slope=(Yright[l]-Yleft[l])/denom;
     j_old=ywhole(Yleft[l]);
     for (ipix=ipixleft; ipix<=ipixright; ipix++)
     { if (ipix==ipixright) jI=ywhole(Yright[l]); else
         jI=ywhole(Yleft[l]+(xreal(ipix+1)-Xleft[l])*slope);
       if (topcode[l])
       { UPPER[ipix]=max3(j_old,jI,UPPER[ipix]);
         UP[ipix]=min3(j_old,jI,UP[ipix]);
       } else
       { LOWER[ipix]=min3(j_old,jI,LOWER[ipix]);
         LOW[ipix]=max3(j_old,jI,LOW[ipix]);
       }
       j_old=jI;
     }
   }

   /* For screen column ipix, the triangle is associated only */
   /* with pixels in the rows LOWER[ipix], ... ,UPPER[ipix].  */
   /* The subrange LOW[ipix]+1,...,UP[ipix]-1 of these  rows  */
   /* denote pixels that lie completely whithin the triangle. */
   /*                                                         */
   /*  ࠭  ⮫ ipix  㣮쭨  樨 */
   /* ⮫쪮  ᥫ  ப LOWER[ipix],..,UPPER[ipix] */
   /*  LOW[ipix]+1,...,UP[ipix]-1  ப  砥 */
   /* ᥫ,       㣮쭨. */

   for (ipix=ipixmin; ipix<=ipixmax; ipix++)
   for (jpix=LOWER[ipix]; jpix<=UPPER[ipix]; jpix++)
   { pointer=&(SCREEN[ipix][jpix]);
     if (jpix>LOW[ipix] && jpix<UP[ipix])
     { xR=Xmin+(ipix+0.5)*deltaX;
       yR=Ymin+(jpix+0.5)*deltaY;
       denom=a*xR+b*yR+c*d;
       dist =
        fabs(denom)>eps ? h*sqrt(xR*xR+yR*yR+1.)/denom : big;
     /* The line from viewpoint E to pixel point (xR, yR, 1) */
     /* intersects plane ABC at a distance dist from E.      */
     /* ﬠ  窨  E   ᥫ  (xR, yR, 1) */
     /* ᥪ ᪮ ABC  ﭨ dist  E.    */
       if (dist < pointer->tr_dist)
       { pointer->tr_cov=ntr; pointer->tr_dist=dist;
       }
     } else                   /* Add triangle to screen list: */
		/* 㣮쭨   ࠭ ᯨ */
     { pnode=(struct node *)malloc(sizeof(struct node));
       if (pnode==NULL) errmes /* "Memory allocation error 4" */
			      ("訡 3 । ");
       pnode->jtr = ntr; pnode->next = pointer->start;
       pointer->start = pnode;
     }
   }
   ntr++;
 }

 /*---------------------------------------------------------*/
 errmes(str) char *str;
 { fatal(); printf("%s\n", str); exit(1);
      /* fatal is defined in the same file as endgr etc.    */
      /* fatal ।  ⮬  䠩,   endgr  . */
 }

 /*---------------------------------------------------------*/
 coeff(rho, theta, phi) double rho, theta, phi;
 { double th, ph, costh, sinth, cosph, sinph, factor;
   factor=atan(1.0)/45.0;
	      /* Angles in radians: */   /*   ࠤ */
   th=theta*factor; ph=phi*factor;
   costh=cos(th); sinth=sin(th);
   cosph=cos(ph); sinph=sin(ph);
		    /* Elements of matrix V, see Eq. (4-9): */
		    /*   V, . (4.9):       */
   v11=-sinth; v12=-cosph*costh; v13=-sinph*costh;
   v21=costh;  v22=-cosph*sinth; v23=-sinph*sinth;
               v32=sinph;        v33=-cosph;
                                 v43=rho;
 }

 /*---------------------------------------------------------*/
 viewing(x, y, z, pxe, pye, pze)
   double x, y, z, *pxe, *pye, *pze;
 {            /* Eye coordinates, computed as in Eq. (4-2): */
	      /*  न,  塞  (4.2): */
   *pxe = v11*x + v21*y;
   *pye = v12*x + v22*y + v32*z;
   *pze = v13*x + v23*y + v33*z + v43;
 }

 /*---------------------------------------------------------*/
 linesegment(xP, yP, zP, xQ, yQ, zQ, k0)
   double xP, yP, zP, xQ, yQ, zQ; int k0;
 { /* Line segment PQ is to be drawn, as far as it is not    */
   /* hidden by the triangles trset[k0] to trset[ntrset-1].  */
   /* १ אַ  PQ 稢, ᪮   */
   /*  㣮쭨  trset[k0]  trset[ntrset-1]. */
   int j, k=k0, worktodo=1, A, B, C, i, Pbeyond, Qbeyond,
     outside, Poutside, Qoutside, eA, eB, eC, sum;
   double a, b, c, h, hP, hQ, r1, r2, r3,
     xA, yA, zA, xB, yB, zB, xC, yC, zC,
     dA, dB, dC, labmin, labmax, lab, mu,
     xmin, ymin, zmin, xmax, ymax, zmax,
     C1, C2, C3, K1, K2, K3, denom1, denom2,
     Cpos, Ppos, Qpos, aux, eps1;
   while (k<ntrset)
   { j=trset[k];
     ptriangle=TRIANGLE+j; /* = &TRIANGLE[j] */
     a=ptriangle->a; b=ptriangle->b; c=ptriangle->c;
     h=ptriangle->h;

				     /* Test 1: */  /*  1 */
     hP=a*xP+b*yP+c*zP; hQ=a*xQ+b*yQ+c*zQ;
     eps1=eps+eps*h;
     if (hP-h<=eps1 && hQ-h<=eps1) {k++; continue;}
		   /* PQ not behind ABC */ /* PQ   ABC*/

				     /* Test 2: */  /*  2 */
     K1=yP*zQ-yQ*zP; K2=zP*xQ-zQ*xP; K3=xP*yQ-xQ*yP;
     A=ptriangle->A; B=ptriangle->B; C=ptriangle->C;
     pvertex=VERTEX+A;
     xA = pvertex->x; yA = pvertex->y; zA = pvertex->z;
     pvertex=VERTEX+B;
     xB = pvertex->x; yB = pvertex->y; zB = pvertex->z;
     pvertex=VERTEX+C;
     xC = pvertex->x; yC = pvertex->y; zC = pvertex->z;
     dA=K1*xA+K2*yA+K3*zA;
     dB=K1*xB+K2*yB+K3*zB;
     dC=K1*xC+K2*yC+K3*zC;
     /* If dA, dB, dC have the same sign, the vertices      */
     /* A, B, C lie at the same side of plane EPQ.          */
     /* ᫨ dA, dB, dC   ,  設  */
     /* A, B, C 室   ஭  ᪮ EPQ. */
     eA= dA>eps ? 1 : dA<meps ? -1 : 0;
     eB= dB>eps ? 1 : dB<meps ? -1 : 0;
     eC= dC>eps ? 1 : dC<meps ? -1 : 0;
     sum = eA+eB+eC;
     if (abs(sum)>=2) { k++; continue; }
     /* If this test succeeds, the (infinite) line PQ lies  */
     /* outside pyramid EABC (or the line and the pyramid   */
     /* have  at most one point in common).                 */
     /* If the test fails, there is a point of intersection.*/
     /* ᫨   襭 ᯥ譮,  (᪮筠)   */
     /* ﬠ  PQ   ࠬ EABC             */
     /* (   ࠩ    ).       */
     /* ᫨   믮,   窠 祭.*/

				   /* Test 3: */  /*  3 */
     Poutside=Qoutside=0; labmin=1.; labmax=0.;
     for (i=0; i<3; i++)
     { C1=yA*zB-yB*zA; C2=zA*xB-zB*xA; C3=xA*yB-xB*yA;
		    /* C1 x + C2 y + C3 z = 0  is plane EAB */
		    /* ࠢ 뢠 ᪮ EAB    */
       Cpos=C1*xC+C2*yC+C3*zC;
       Ppos=C1*xP+C2*yP+C3*zP;
       Qpos=C1*xQ+C2*yQ+C3*zQ;
       denom1=Qpos-Ppos;
       if (Cpos>eps)
       { Pbeyond= Ppos<meps; Qbeyond= Qpos<meps;
         outside= Pbeyond && Qpos<=eps ||
                  Qbeyond && Ppos<=eps;
       } else if (Cpos<meps)
       { Pbeyond= Ppos>eps; Qbeyond= Qpos>eps;
         outside= Pbeyond && Qpos>=meps ||
                  Qbeyond && Ppos>=meps;
       } else outside=1;
       if (outside) break;
       lab= fabs(denom1)<=eps  ? 1.e7 : -Ppos/denom1;
	     /* lab indicates where PQ meets plane EAB      */
	     /* ࠬ lab 㪠뢠   祭 */
	     /* १ PQ  ᪮ EAB                 */
       Poutside |= Pbeyond;
       Qoutside |= Qbeyond;
       denom2=dB-dA;
       mu= fabs(denom2)<=eps ? 1.e7 : -dA/denom2;
	      /* mu tells where AB meets plane EPQ          */
	      /* ࠬ mu 㪠뢠   祭 */
	      /* १ AB  ᪮ EPQ                */

       if (mu>=meps && mu<=oneplus &&
           lab>=meps && lab<=oneplus)
       { if (lab<labmin) labmin=lab;
         if (lab>labmax) labmax=lab;
       }
       aux=xA; xA=xB; xB=xC; xC=aux;
       aux=yA; yA=yB; yB=yC; yC=aux;
       aux=zA; zA=zB; zB=zC; zC=aux;
       aux=dA; dA=dB; dB=dC; dC=aux;
     }
     if (outside) {k++; continue;}

				   /* Test 4: */  /*  4 */
     if (!(Poutside || Qoutside))
     { worktodo=0; break;
		   /* PQ invisible */ /* १ PQ  */
     }
				    /* Test 5: */ /*  5 */
     r1=xQ-xP; r2=yQ-yP; r3=zQ-zP;
     xmin=xP+labmin*r1; ymin=yP+labmin*r2; zmin=zP+labmin*r3;
     if (a*xmin+b*ymin+c*zmin-h<-eps1) { k++; continue; }
     xmax=xP+labmax*r1; ymax=yP+labmax*r2; zmax=zP+labmax*r3;
     if (a*xmax+b*ymax+c*zmax-h<-eps1) { k++; continue; }

     /* If this test succeeds, an intersection of PQ          */
     /* and the pyramid lies in front of plane ABC.           */
     /* ᫨   믮 ᯥ譮,  窠 祭 */
     /* १ PQ  ࠬ 室 । ᪮ ABC. */


				     /* Test 6: */  /*  6 */
     if (Poutside || hP<h-eps1)
       linesegment(xP, yP, zP, xmin, ymin, zmin, k+1);
     if (Qoutside || hQ<h-eps1)
       linesegment(xQ, yQ, zQ, xmax, ymax, zmax, k+1);
     worktodo=0; break;
   }

   if (worktodo)
   { move(d*xP/zP+c1, d*yP/zP+c2);
     draw(d*xQ/zQ+c1, d*yQ/zQ+c2);
   }
 }

 /*---------------------------------------------------------*/
 init_viewport(pXMIN,pXMAX,pYMIN,pYMAX)
   double *pXMIN, *pXMAX, *pYMIN, *pYMAX;
 { double XMIN, XMAX, YMIN, YMAX, len=0.2;
   printf
 /* "Give viewport boundaries XMIN, XMAX, YMIN, YMAX" */
 (" ࠭  뢮 XMIN, XMAX, YMIN, YMAX,\n");
   printf /* "for a full screen: 0  10  0  7 " */
	  ("  ࠭ : 0  10  0  7\n");
   scanf("%lf %lf %lf %lf", &XMIN, &XMAX, &YMIN, &YMAX);
			/* Show the four viewport corners:  */
		 /* ન஢  㣫  뢮 */
   initgr();
   move(XMIN,YMIN+len); draw(XMIN,YMIN); draw(XMIN+len,YMIN);
   move(XMAX-len,YMIN); draw(XMAX,YMIN); draw(XMAX,YMIN+len);
   move(XMAX,YMAX-len); draw(XMAX,YMAX); draw(XMAX-len,YMAX);
   move(XMIN+len,YMAX); draw(XMIN,YMAX); draw(XMIN,YMAX-len);
   move((XMIN+XMAX)/2,YMIN); draw((XMIN+XMAX)/2,YMIN);
	  /* Dot in the middle of bottom viewport boundary  */
	  /* for orientation.                               */
	  /* 窠  ।  ࠭  뢮 */
	  /* 祭  । ਥ樨.        */
   *pXMIN=XMIN; *pXMAX=XMAX; *pYMIN=YMIN; *pYMAX=YMAX;
 }
