/* LINDRAW: ⥩訩 ᪨ .    ࠡ⠥
	     ࠭ࠬ Turbo C, Lattice C  Microsoft C.
	     ᯮ짮 ᪨ :
	     -  ७ ᪨  EGA (640 x 350);
	     -  ⭮ ᪨  CGA (640 x 200);
	     -  ᪨  㫥 HGA (720 x 348).

	    C. ⠪ :
	    .ࠫ. 設 䨪  ᮭ .
	    .ࠫ. ࠪ⨢ 嬥ୠ 設 䨪.
	    좮 .. - ॢ  ᪨ .
*/
/* LINDRAW: A simple graphics package.
      This version works for Turbo C, Lattice C, and Microsoft C.

      For: Enhanced Graphics Adapter (EGA, 640 x 350)
           Color Graphics Adapter (CGA, 640 x 200)
           Hercules Graphics Adapter (HGA, 720 x 348)
      See also:
      L. Ammeraal (1987). Computer Graphics for the
	  IBM PC, Chichester: John Wiley & Sons.
      L. Ammeraal (1988). Interactive 3D Computer Graphics,
	  Chichester: John Wiley & Sons.
*/
#include <stdio.h>
#include <dos.h>

#include <stdlib.h>
#include <string.h>

union REGS regs;

/*  ᯮ짮 ࠭ Lattice-C ⠭ 'LATTICE'
   ।  䠩 "dos.h".
    ࠭ Turbo C ⠭ '__TURBOC__' ।⠢ 
    ம। ( ஬ ᮤন  ᨨ).
   ᫨   'LATTICE'  '__TURBOC__' , 
   । 稥 ࠭ Microsoft C.

   For Lattice-C users the constant 'LATTICE' is defined in dos.h.
   In Turbo C, the constant '__TURBOC__' is a predefined macro
   (which encodes the version number).
   If both 'LATTICE' and '__TURBOC__' are unknown names, it is
   assumed that Microsoft C is being used:
*/

#ifdef LATTICE
#else
#ifdef __TURBOC__
#else
#define MICROSOFT 1
#endif
#endif

#ifndef __TURBOC__
#define outport(port, word) outp(port, word)
#endif

#ifdef LATTICE

  unsigned int _STACK = 15000;
    /*  Lattice C ࠧ ⥪  㬮砭 ᫨誮  */
    /* The default stacksize in Lattice C is too small   */

  int ctrlbrk(int (*)());

  int ctrlbrk(brfun) int (*brfun)();
  { onbreak(brfun);         /* 'ctrlbrk' in Turbo C is called */
  }                         /* 'onbreak' in Lattice C         */
		  /*  Turbo C 뢠 㭪 'ctrlbrk'   */
		  /*  Lattice C 뢠 㭪 'onbreak' */
#else
#include <conio.h>
/* With Turbo C and Microsoft C, getch is declared in conio.h */
/*  Turbo C  Microsoft C 㭪 'getch'   䠩  */
/* 'conio.h'                                                  */

#endif

#ifdef MICROSOFT
#include <signal.h>

  int ctrlbrk(int (*)());

  int ctrlbrk(brfun) int (*brfun)();
  { if (brfun == 0) signal(SIGINT, SIG_DFL);
             else signal(SIGINT, brfun);
  }

#endif

int in_textmode=1, X__max, Y__max, adaptype;

float x_max=10.0, y_max=7.0, horfact, vertfact;

static int old_vid_state, X1, Y1,
   Ystart[350]; /*  350 >=  Ymax + 1 */

unsigned int startsegment;
unsigned long int startaddress;

static char
   gtable[12] =
     {53, 45, 46,  7, 91, 2, 87, 87, 2,  3,  0,  0},
   ttable[12] =
     {97, 80, 82, 15, 25, 6, 25, 25, 2, 13, 11, 12},
   zeros[128]; /* implicitly initialized to zero */
	       /*  樠 ﬨ */
void to_text(void);
void textXY(int, int, char *);
int IX(double);
int IY(double);

int IX(x) double x; { return (int)(x*horfact+0.5); }
int IY(y) double y; { return Y__max-(int)(y*vertfact+0.5); }

#ifdef LATTICE
#define poke1 poke
#define peek1 peek
#else
  static void poke1(unsigned, unsigned, char *, unsigned);

  static void poke1(segment, offset, buffer, n)
    unsigned segment, offset; char *buffer; unsigned n;
  { unsigned srcseg, srcoff;
    char far *p = (char far *)buffer;
    srcseg = FP_SEG(p);
    srcoff = FP_OFF(p);
    movedata(srcseg, srcoff, segment, offset, n);
  }

  static void peek1(unsigned, unsigned, char *, unsigned);

  static void peek1(segment, offset, buffer, n)
    unsigned segment, offset; char *buffer; unsigned n;
  { unsigned destseg, destoff;
    char far *p = (char far *)buffer;
    destseg = FP_SEG(p);
    destoff = FP_OFF(p);
    movedata(segment, offset, destseg, destoff, n);
  }
#endif

static void error(char *);

static void error(str) char *str;
	 /* 뢮 ᮮ饭  蠥 믮 ணࠬ */
	 /* Display a message and terminate program execution      */
{ if (!in_textmode) to_text();
  printf("%s\n", str); exit(1);
}

int iscolor(void);

int iscolor()    /* Find out which adapter is used         */
		 /* । ⨯ ਬ塞  */
{ char ch0, ch1, x;
  if (peek1(0x40, 0x87, &ch0, 1), ch0) return 2;
  /* EGA, see Dr. Dobbs Journal, November 1987, p.34 */
  int86(0x11, &regs, &regs);
  if ((regs.x.ax & 0x30) != 0x30) return 1;         /* CGA */
		 /* Color graphics    ⭠ 䨪      */
  outport(0x3BF, 3);
    /* Configuration switch   ४⥫ 䨣樨   */
  peek1(0xB800, 0, &ch0, 1);
	       /* Try to read ch0 from screen memory       */
	       /* ⪠  ch0  ࠭  */
  ch1 = ch0 ^ 0xFF;
	       /* Find some value different from  ch0      */
	       /* ஥ ᫮, ⫨筮  ch0         */
  poke1(0xB800, 0, &ch1, 1);
	       /* Try to write this into screen memory     */
	       /* ⪠   ᫮        */
  peek1(0xB800, 0, &x, 1);
	       /* Try to read the latter value             */
	       /* ⪠  ᫥ 祭     */
  poke1(0xB800, 0, &ch0, 1);
	       /* Restore the old value  ch0               */
	       /* ⠭ ண 祭 ch0      */
  return ( x == ch1 ? 0 : -1);
	       /* Has written value been read?             */
	       /* 뫮  ⠭ ᠭ 祭?   */
}

static void setgrcon(int);

static void setgrcon(adaptype) int adaptype;
/* Set graphics constants */  /* ⠭ ᪨ ⠭ */
{ int Y, c1, c2, c3;
  if (adaptype == 2)
  { startsegment = 0xA000;
    startaddress = 0xA0000000L; /* EGA      */
  } else
  { startsegment = 0xB800;
    startaddress = 0xB8000000L; /* CGA, HGA */
  }
  if (adaptype == 2)
  { X__max = 639; Y__max = 349;
    for (Y=0; Y<=Y__max; Y++) Ystart[Y] = 80 * Y;
    return;
  }
  if (adaptype == 1)
  { X__max = 639; Y__max = 199;
    c1 = 1; c2 = 80; c3 = 1;
  } else
  { X__max = 719; Y__max = 347;
    c1 = 3; c2 = 90; c3 = 2;
  }
  for (Y=0; Y<=Y__max; Y++)
  Ystart[Y] = 0x2000*(Y&c1) + c2*(Y>>c3);
}

static int grbrfun(void);

static int grbrfun()
/* ᯮ 㭪樥 'ctrlbrk'  । ⢨
     ᮫쭮 뢠.
   Used by  ctrlbrk, to specify what to do with a console break
*/
{ to_text(); exit(0); return 0;
}

static void initcgaorega(int);

static void initcgaorega(mode) int mode;
	/* Switch to graphics mode (CGA or EGA)               */
	/* ४祭  ᪨ ० ( CGA  EGA) */
{ regs.h.ah = 15;            /* Inquire current video state   */
			     /*  ⥪饣  ०  */
  int86(0x10, &regs, &regs);
  old_vid_state = regs.h.al;
  regs.h.ah = 0;             /* Set graphics mode             */
			     /* ⠭ ᪮ ० */
  regs.h.al = mode;
      /* mode = 6:  CGA, 640 x 200, black/white   ୮/ */
      /* mode = 16: EGA, 640 x 350, black/white   ୮/ */
  int86(0x10, &regs, &regs);
}

static void initmongr(void);

static void initmongr()
/* Switch to graphics mode (monochrome graphics)                */
/* ४祭  ᪨ ० ( ஬ ) */
{ int i, j;
  outport(0x3B8, 0x82);
  for (i=0; i<12; i++)
  { outport(0x3B4, i);
    outport(0x3B5, gtable[i]);
  }
  for (j=0; j<256; j++) poke1(0xB800, j << 7, zeros, 128);
  outport(0x3B8, 0x8A);
}

void initgr(void);

void initgr()                           /* Initialize graphics */
			  /* 樠 ᪮  */
{ if (!in_textmode)
    error               /* "initgr is called in graphics mode" */
	 ("㭪 'initgr' 맢  ᪮ ०");
  adaptype = iscolor();
  if (adaptype < 0) error          /*  "Wrong display adapter" */
			  (" ᪨ ");
  ctrlbrk(grbrfun);               /* Set break trap, Turbo C   */
	 /* ⠭ ணࠬ ࠡ⪨ 뢠  Turbo C */
  if (adaptype == 2) initcgaorega(16); /* EGA */ else
  if (adaptype == 1) initcgaorega(6);  /* CGA */ else
  /* adaptype == 0 */ initmongr();     /* HGA */
  setgrcon(adaptype);
  in_textmode=0;
  horfact = X__max/x_max; vertfact = Y__max/y_max;
}

static void endcolgr(void);

static void endcolgr()
	/* Revert to text mode (color graphics or EGA):        */
	/*   ⥪⮢ ० ( 梥⭮ 䨪)     */
{ regs.h.ah = 0; regs.h.al = old_vid_state;
  int86(0x10, &regs, &regs);
}

static void endmongr(void);

static void endmongr()
	/* Revert to text mode (monochrome graphics):          */
	/*   ⥪⮢ ० ( ஬ 䨪) */
{ int i;
  outport(0x3B8, 0);
  for (i=0; i<12; i++)
  { outport(0x3B4, i);
    outport(0x3B5, ttable[i]);
  }
  for (i=0; i<256; i++)
    poke1(0xB000, i << 4, "\40\7\40\7\40\7\40\7\40\7\40\7\40\7\40\7", 16);
  outport(0x3B8, 0x08);
}

static int txtbrfun(void);

static int txtbrfun()
{ return 0;
}

void to_text(void);

void to_text()
	/* Revert to text mode */  /*   ⥪⮢ ० */
{ if (in_textmode)
    error          /* "endgr or to_text is called in text mode" */
    ("㭪樨 'endgr'  'to_text' 맢  ⥪⮢ ०");
  if (adaptype) endcolgr(); /* CGA or EGA */
           else endmongr(); /* HGA        */
  in_textmode = 1;
  ctrlbrk(txtbrfun);
  /* Restore default break interrupt handler                    */
  /* ⠭ ணࠬ ࠡ⪨ 뢠  㬮砭 */
}

void endgr(void);

void endgr()
	/* Wait until any key is hit and revert to text mode    */
	/*     室  ⥪⮢ ० */
{ getch();
  to_text();
}

void dot(int, int);

void dot(X, Y) int X, Y;     /* Light or darken a pixel       */
			     /* ᢥ⪠  襭 ᥫ */
{ unsigned int pattern, offset;
  char lastchar;
  unsigned long int address;
  offset = Ystart[Y] + (X>>3);
  pattern = 0x80 >> (X&7);

#ifdef LATTICE
	 /* 'far' keyword not available in Lattice 3.1        */
	 /* 祢 ᫮ 'far'  ਬ  Lattice 3.1 */
  peek(startsegment, offset, &lastchar, 1);
  lastchar |= pattern;
  poke(startsegment, offset, &lastchar, 1);
#else
  address = startaddress + offset;
  lastchar = *(char far *) address;
  lastchar |= pattern;
  *(char far *) address = lastchar;
#endif

}


static void checkbreak(void);

static void checkbreak()
{ char ch;
  if (kbhit()) { ch = getch(); kbhit(); ungetch(ch); }
}

void draw_line(int, int, int, int);

void draw_line(X1, Y1, X2, Y2) int X1, Y1, X2, Y2;
  /* 稢 १  窨 (X1, Y1)   (X2, Y2); */
  /* 祭 X1, Y1, X2, Y2   ᥫ न.  */
  /* Draw the line segment from (X1, Y1) to (X2, Y2);         */
  /* X1, Y1, X2, Y2 are pixel coordinates.                    */

{ int X, Y, T, E, dX, dY, denom, Xinc = 1, Yinc = 1,
  vertlonger = 0, aux;
  checkbreak();        /* To make DOS check for console break */
	     /* 㦤  ஢ ᮫쭮 뢠 */
  if (in_textmode)
    error             /* "Not in graphics mode (call initgr)" */
      ("  ᪮ ०, 㦥 맮 㭪樨 'initgr'");
  dX = X2 - X1; dY = Y2 - Y1;
  if (dX < 0) {Xinc = -1; dX = -dX;}
  if (dY < 0) {Yinc = -1; dY = -dY;}
  if (dY > dX)
  { vertlonger = 1; aux = dX; dX = dY; dY = aux;
  }
  denom = dX << 1;
  T = dY << 1;
  E = -dX; X = X1;
  Y = Y1;
  if (vertlonger)
  while (dX-- >= 0)
  { dot(X, Y);
    if ((E += T) > 0)
    { X += Xinc; E -= denom;
    }
    Y += Yinc;
  } else
  while (dX-- >= 0)
  { dot(X, Y);
    if ((E += T) > 0)
    { Y += Yinc; E -= denom;
    }
    X += Xinc;
  }
}

void fatal(void);

void fatal()
   /* 稢 ,    , */
   /* ᫥ 祣   ⥪⮢ ०.                   */
   /* Draw a diagonal, then wait until a key is pressed, and  */
   /* finally revert to text mode.                            */

{ draw_line(0, Y__max,  X__max, 0); endgr();
}

static void check(int, int);

static void check(X, Y) int X, Y;
 /* ᫨ 窠 (X, Y)   ࠭ ࠭,  饭  */
 /* 㭪樨 'fatal', ⮡ࠦ  न  ⠭ */
 /* If point (X, Y) lies outside the screen boundaries, then  */
 /* call  fatal, display the incorrect coordinates, and stop  */

{ if (X < 0 || X > X__max || Y < 0 || Y > Y__max)
  { fatal();
    printf
     /* "Point outside screen (X and Y are pixel coordinates) */
     ("窠  ࠭ (X  Y  ᥫ न) :\n");
    printf("X = %d       Y = %d\n", X, Y);
    printf("x = %10.3f   y = %10.3f\n",
    X/horfact, (Y__max-Y)/vertfact);
    printf(
    "X__max = %d  Y__max = %d  x_max = %f y_max = %f\n",
     X__max, Y__max, x_max, y_max);
    printf("horfact = %f  vertfact = % f\n",
            horfact, vertfact);
    exit(1);
  }
}

void move(double, double);

void move(x, y) double x, y;
      /* ७ ⥪饩 窨    न⠬ (x, y), */
      /* 祭 x  y  ࠭ न.               */
			 /* Move the current point to (x, y); */
			  /*  x and y are screen coordinates  */
{ X1 = IX(x); Y1 = IY(y); check(X1, Y1);
}

void draw(double, double);

void draw(x, y) double x, y;
     /* 稢 १  ⥪饩 窨   (x, y)  */
     /* Draw a line segment from the current point to  (x, y) */
{ int X2, Y2;
  X2 = IX(x); Y2 = IY(y); check(X2, Y2);
  draw_line(X1, Y1, X2, Y2);
  X1 = X2; Y1 = Y2;
}
